<script>
import { debounce } from 'lodash'
import {
  GlFilteredSearchToken,
  GlFilteredSearchSuggestion,
  GlDropdownText,
  GlLoadingIcon,
  GlIcon,
} from '@gitlab/ui'

export default {
  components: {
    GlFilteredSearchToken,
    GlFilteredSearchSuggestion,
    GlDropdownText,
    GlLoadingIcon,
    GlIcon,
  },
  props: {
    config: {
      type: Object,
      required: true,
    },
    value: {
      type: Object,
      required: true,
    },
    active: {
      type: Boolean,
      required: true,
    },
    suggestionsLoading: {
      type: Boolean,
      required: false,
      default: false,
    },
    suggestions: {
      type: Array,
      required: false,
      default: () => [],
    },
    getActiveTokenValue: {
      type: Function,
      required: false,
      default: (suggestions, data) =>
        suggestions.find(({ value }) => value === data),
    },
    valueIdentifier: {
      type: Function,
      required: false,
      default: (token) => token.id,
    },
    searchBy: {
      type: String,
      required: false,
      default: undefined,
    },
  },
  data() {
    return {
      searchKey: '',
    }
  },
  computed: {
    availableSuggestions() {
      return this.suggestions.filter((suggestion) =>
        suggestion.text?.toLowerCase().includes(this.searchKey?.toLowerCase()),
      )
    },
    activeTokenValue() {
      const data = this.value.data
      return this.getActiveTokenValue(this.suggestions, data)
    },
  },
  methods: {
    handleInput: debounce(function ({ data }) {
      this.searchKey = data
      this.$emit('fetch-suggestions', this.searchKey)
    }, 500),
    handleTokenValueSelected(selectedValue) {
      this.$emit('input', { ...this.value, data: selectedValue })
    },
  },
}
</script>

<template>
  <gl-filtered-search-token
    :config="config"
    :value="value"
    :active="active"
    v-bind="$attrs"
    v-on="$listeners"
    @input="handleInput"
    @select="handleTokenValueSelected"
  >
    <template #view-token="viewTokenProps">
      <slot
        name="view-token"
        :view-token-props="{
          ...viewTokenProps,
          activeTokenValue,
        }"
      ></slot>
    </template>
    <template #suggestions>
      <gl-loading-icon v-if="suggestionsLoading" size="sm" />
      <template v-else-if="availableSuggestions.length">
        <gl-filtered-search-suggestion
          v-for="(suggestion, index) in availableSuggestions"
          :key="index"
          :value="suggestion.value"
        >
          <div class="gl-display-flex" :class="suggestion.class">
            <gl-icon
              v-if="suggestion.icon !== ''"
              :name="suggestion.icon"
              class="gl-mr-3"
            />
            <span> {{ suggestion.text }}</span>
          </div>
        </gl-filtered-search-suggestion>
      </template>
      <gl-dropdown-text v-else>No suggestions found</gl-dropdown-text>
    </template>
  </gl-filtered-search-token>
</template>
